#pragma once

#include <Textur.h>

#include "Block.h"
#include "BlockType.h"
#include "Item.h"

class BlockType;
class ItemType;
class DirtBlockType;
class DirtBlockItemType;

class BasicBlock : public Block
{
    Framework::Textur* breakTextur;
public:
    BasicBlock( const BlockType* zType, const char* texture, ItemType* zTool, Framework::Vec3<int> pos, Framework::Textur* t );
    ~BasicBlock();
    bool needRenderPolygon( int index ) override;
    virtual Textur* zEffectTextur() override;
    virtual float getEffectPercentage() override;

    friend DirtBlockType;
};

class DirtBlockType : public BlockType
{
    REGISTRABLE( DirtBlockType )

protected:
    DirtBlockType();
    virtual void loadSuperBlock( Block* zBlock, Framework::StreamReader* zReader ) override;

public:
    virtual Block* createBlock( Framework::Vec3<int> position ) override;
    virtual void initializeSuperBlock( Block* zBlock )  override;
    virtual bool needsInstance() const override;
};
REGISTER( DirtBlockType, BlockType )

class DirtBlockItemType : public BasicBlockItemType
{
    REGISTRABLE( DirtBlockItemType )

protected:
    DirtBlockItemType();

public:
    virtual Item* createItem() const override;
    virtual Framework::Model3DTextur* getItemTextur() const override;
};
REGISTER( DirtBlockItemType, ItemType )
