#pragma once

#include <Vec3.h>
#include <ReferenceCounter.h>
#include <HashMap.h>

#include "ItemSlot.h"
#include "Area.h"

class ItemFilter;
class Inventory;

class Inventory : public virtual Framework::ReferenceCounter
{
private:
    Framework::RCArray<ItemSlot>* pullSlotsOrder;
    Framework::RCArray<ItemSlot>* pushSlotsOrder;

protected:
    Framework::Vec3<float> location;
    virtual void loadInventory( Framework::StreamReader* zReader );
    void addSlot( ItemSlot* slot );


public:
    Inventory( const Framework::Vec3<float> location, bool hasInventory );
    virtual ~Inventory();
};